dracut/0015-40network-replace-dhclient-with-wickedd-dhcp-supplic.patch
Thomas Renninger 89f9350d9e Accepting request 314510 from home:trenn:branches:Base:System
- Fix dmraid issue bnc#905746
A    dracut_dmraid_use_udev.patch
- Taken over from SLE12
A    fips_add_aesni-intel.patch
- Do not touch /run vs /var/run bnc#922676
D    0106-dracut-Enable-converting-of-directory-var-run-var-lo.patch
- Update dracut to version 042
Remove these already included or unneeded patches:
D    dracut_v041_to_HEAD.patch
D    0011-Correct-paths-for-openSUSE.patch
D    0068-95fcoe-uefi-Test-for-EFI-firmware.patch
D    0170-enable-logitech-hidpp.patch
Adjust/refresh:
M    0015-40network-replace-dhclient-with-wickedd-dhcp-supplic.patch
M    0016-Add-new-s390x-specific-rule-files.patch
M    0017-45ifcfg-use-distro-specific-scripts.patch
M    0019-40network-Fix-race-condition-when-wait-for-networks.patch
M    0020-00warpclock-Set-correct-timezone.patch
M    0021-95dcssblk-Add-new-module-for-DCSS-block-devices.patch
M    0048-40network-Only-enable-network-interfaces-if-explicit.patch
M    0053-01fips-fixup-loading-issues.patch
M    0056-81cio_ignore-handle-cio_ignore-commandline.patch
M    0057-01fips-Include-some-more-hmacs.patch
M    0058-dracut-add-warning-when-including-unsupported-module.patch
M    0059-99suse-Add-SUSE-specific-initrd-parsing.patch
M    0060-45ifcfg-Add-SUSE-specific-write-ifcfg-file.patch
M    0061-45ifcfg-Fixup-error-message-in-write-ifcfg-suse.patch
M    0066-40network-always-start-netroot-in-ifup.sh.patch
M    0075-95dasd_rules-enable-parsing-of-rd.dasd-commandline-p.patch
M    0076-Correctly-set-cio_ignore-for-dynamic-s390-rules.patch

OBS-URL: https://build.opensuse.org/request/show/314510
OBS-URL: https://build.opensuse.org/package/show/Base:System/dracut?expand=0&rev=219
2015-06-30 12:59:59 +00:00

226 lines
7.5 KiB
Diff

From 0aa152e662d2197f92617da4ab813fcd9be6f90f Mon Sep 17 00:00:00 2001
From: Pavel Wieczorkiewicz <pwieczorkiewicz@suse.com>
Date: Mon, 7 Apr 2014 16:26:57 +0200
Subject: [PATCH] 40network: replace dhclient with wickedd-dhcp-supplicant
SLES12 is using wickedd, so we need to replace dhclient with
wickedd-dhcp-supplicant.
References: bnc#866771
Signed-off-by: Hannes Reinecke <hare@suse.de>
---
modules.d/40network/dhclient-script.sh | 156 ---------------------------------
modules.d/40network/dhclient.conf | 3 -
modules.d/40network/ifup.sh | 97 ++++++++++++++++++--
modules.d/40network/kill-dhclient.sh | 17 ----
modules.d/40network/module-setup.sh | 14 +--
5 files changed, 99 insertions(+), 188 deletions(-)
delete mode 100755 modules.d/40network/dhclient-script.sh
delete mode 100644 modules.d/40network/dhclient.conf
delete mode 100755 modules.d/40network/kill-dhclient.sh
Index: dracut-042/modules.d/40network/dhclient.conf
===================================================================
--- dracut-042.orig/modules.d/40network/dhclient.conf 2015-06-11 17:39:47.000000000 +0200
+++ /dev/null 1970-01-01 00:00:00.000000000 +0000
@@ -1,3 +0,0 @@
-request subnet-mask, broadcast-address, time-offset, routers,
- domain-name, domain-name-servers, domain-search, host-name,
- root-path, interface-mtu;
Index: dracut-042/modules.d/40network/ifup.sh
===================================================================
--- dracut-042.orig/modules.d/40network/ifup.sh 2015-06-24 18:02:05.645160455 +0200
+++ dracut-042/modules.d/40network/ifup.sh 2015-06-24 18:02:05.945177534 +0200
@@ -86,21 +86,106 @@ else
[ -e /tmp/net.$(cat /sys/class/net/$netif/address).did-setup ] && exit 0
fi
+dhcp_apply() {
+ if [ -f /tmp/leaseinfo.${netif}.dhcp.ipv${1:1:1} ]; then
+ . /tmp/leaseinfo.${netif}.dhcp.ipv${1:1:1}
+ else
+ warn "DHCP failed";
+ return 1
+ fi
+
+ if [ -z "${IPADDR}" ] || [ -z "${INTERFACE}" ]; then
+ warn "Missing crucial DHCP variables"
+ return 1
+ fi
+
+ # Assign IP address
+ ip $1 addr add "$IPADDR" ${BROADCAST:+broadcast $BROADCAST} dev "$INTERFACE"
+
+ # Assign network route the interface is attached to
+ if [ -n "${NETWORK}" ]; then
+ ip $1 route add "$NETWORK"/"$PREFIXLEN" dev "$INTERFACE"
+ fi
+
+ # Assign provided routes
+ local r route=()
+ if [ -n "${ROUTES}" ]; then
+ for r in ${ROUTES}; do
+ route=(${r//,/ })
+ ip $1 route add "$route[0]"/"$route[1]" via "$route[2]" dev "$INTERFACE"
+ done
+ fi
+
+ # Assign provided routers
+ local g
+ if [ -n "${GATEWAYS}" ]; then
+ for g in ${GATEWAYS}; do
+ ip $1 route add default via "$g" dev "$INTERFACE" && break
+ done
+ fi
+
+ # Setup hostname
+ [ -n "${HOSTNAME}" ] && hostname "$HOSTNAME"
+
+ # If nameserver= has not been specified, use what dhcp provides
+ if [ ! -s /tmp/net.$netif.resolv.conf ]; then
+ if [ -n "${DNSDOMAIN}" ]; then
+ echo domain "${DNSDOMAIN}"
+ fi >> /tmp/net.$netif.resolv.conf
+
+ if [ -n "${DNSSEARCH}" ]; then
+ echo search "${DNSSEARCH}"
+ fi >> /tmp/net.$netif.resolv.conf
+
+ if [ -n "${DNSSERVERS}" ] ; then
+ for s in ${DNSSERVERS}; do
+ echo nameserver "$s"
+ done
+ fi >> /tmp/net.$netif.resolv.conf
+ fi
+ [ -e /tmp/net.$netif.resolv.conf ] && \
+ cp -f /tmp/net.$netif.resolv.conf /etc/resolv.conf
+
+ info "DHCP is finished successfully"
+ return 0
+}
+
# Run dhclient
do_dhcp() {
# dhclient-script will mark the netif up and generate the online
# event for nfsroot
# XXX add -V vendor class and option parsing per kernel
- [ -e /tmp/dhclient.$netif.pid ] && return 0
+ [ -f /tmp/leaseinfo.${netif}.dhcp.ipv${1:1:1} ] && return 0
+
+ info "Preparation for DHCP transaction"
+
+ local dhclient=''
+ if [ "$1" = "-4" ] ; then
+ dhclient="wickedd-dhcp4"
+ elif [ "$1" = "-6" ] ; then
+ dhclient="wickedd-dhcp6"
+ fi
+
+ # Address changed
+ ip $1 addr flush dev "$netif"
if ! iface_has_link $netif; then
- echo "No carrier detected"
- return 1
+ warn "No carrier detected"
+ warn "Trying to set $netif up..."
+ ip $1 link set dev "$netif" up
+ if ! iface_has_link $netif; then
+ warn "Failed..."
+ return 1
+ fi
fi
+
echo "Starting dhcp for interface $netif"
- dhclient "$@" -1 -q -cf /etc/dhclient.conf -pf /tmp/dhclient.$netif.pid -lf /tmp/dhclient.$netif.lease $netif \
- || echo "dhcp failed"
+ $dhclient --test $netif > /tmp/leaseinfo.${netif}.dhcp.ipv${1:1:1}
+ dhcp_apply $1 || return $?
+
+ echo $netif > /tmp/setup_net_${netif}.ok
+ return 0
}
load_ipv6() {
@@ -226,8 +311,6 @@ if [ -e /tmp/team.info ]; then
fi
fi
-# XXX need error handling like dhclient-script
-
if [ -e /tmp/bridge.info ]; then
. /tmp/bridge.info
# start bridge if necessary
Index: dracut-042/modules.d/40network/kill-dhclient.sh
===================================================================
--- dracut-042.orig/modules.d/40network/kill-dhclient.sh 2015-06-11 17:39:47.000000000 +0200
+++ /dev/null 1970-01-01 00:00:00.000000000 +0000
@@ -1,15 +0,0 @@
-#!/bin/sh
-
-for f in /tmp/dhclient.*.pid; do
- [ -e $f ] || continue
- read PID < $f;
- kill $PID >/dev/null 2>&1
-done
-
-sleep 0.1
-
-for f in /tmp/dhclient.*.pid; do
- [ -e $f ] || continue
- read PID < $f;
- kill -9 $PID >/dev/null 2>&1
-done
Index: dracut-042/modules.d/40network/module-setup.sh
===================================================================
--- dracut-042.orig/modules.d/40network/module-setup.sh 2015-06-11 17:39:47.000000000 +0200
+++ dracut-042/modules.d/40network/module-setup.sh 2015-06-24 18:02:05.949177762 +0200
@@ -1,10 +1,13 @@
#!/bin/bash
+WICKEDD_DHCP_PATH="/usr/lib/wicked/bin"
+WICKED_EXT_PATH="/etc/wicked/extensions"
+
# called by dracut
check() {
local _program
- require_binaries ip arping dhclient || return 1
+ require_binaries ip arping $WICKEDD_DHCP_PATH/wickedd-dhcp4 $WICKEDD_DHCP_PATH/wickedd-dhcp6 || return 1
return 255
}
@@ -23,17 +26,18 @@ installkernel() {
# called by dracut
install() {
local _arch _i _dir
- inst_multiple ip arping dhclient sed
+ inst_multiple ip arping hostname sed
inst_multiple -o ping ping6
inst_multiple -o brctl
inst_multiple -o teamd teamdctl teamnl
inst_simple /etc/libnl/classid
+ inst_simple "$WICKEDD_DHCP_PATH/wickedd-dhcp4" "/usr/sbin/wickedd-dhcp4"
+ inst_simple "$WICKEDD_DHCP_PATH/wickedd-dhcp6" "/usr/sbin/wickedd-dhcp6"
+ inst_libdir_file "libwicked*.so.*"
+ inst_libdir_file "libdbus-1.so.*"
inst_script "$moddir/ifup.sh" "/sbin/ifup"
inst_script "$moddir/netroot.sh" "/sbin/netroot"
- inst_script "$moddir/dhclient-script.sh" "/sbin/dhclient-script"
inst_simple "$moddir/net-lib.sh" "/lib/net-lib.sh"
- inst_simple -H "/etc/dhclient.conf"
- cat "$moddir/dhclient.conf" >> "${initdir}/etc/dhclient.conf"
inst_hook pre-udev 50 "$moddir/ifname-genrules.sh"
inst_hook pre-udev 60 "$moddir/net-genrules.sh"
inst_hook cmdline 91 "$moddir/dhcp-root.sh"
@@ -44,7 +48,6 @@ install() {
inst_hook cmdline 97 "$moddir/parse-bridge.sh"
inst_hook cmdline 98 "$moddir/parse-ip-opts.sh"
inst_hook cmdline 99 "$moddir/parse-ifname.sh"
- inst_hook cleanup 10 "$moddir/kill-dhclient.sh"
_arch=$(uname -m)